const THUMBSDOWN_SQLITE_FILENAME = "thumbsdown.sqlite";

const THUMBSDOWN_SQL_EXECUTOR_INIT_CONFIG = [
    "CREATE TABLE meta ('name' VARCHAR PRIMARY KEY NOT NULL, 'value' VARCHAR NOT NULL)",
    "CREATE TABLE scripts ('id' INTEGER PRIMARY KEY NOT NULL, 'name' VARCHAR NOT NULL, 'regexp' VARCHAR NOT NULL, 'type' INTEGER NOT NULL, 'source' INTEGER, 'pattern' VARCHAR, 'template' VARCHAR, 'script' VARCHAR)",
    "INSERT INTO meta (name, value) VALUES ('version', 1)"
];

const THUMBSDOWN_SQL_EXECUTOR_CONFIG =
{
    getMeta:
    {
        stmt: "SELECT value FROM meta WHERE name = ?1",
        result: "string"
    },
    getScripts:
    {
        stmt: "SELECT id, name, regexp, type, source, pattern, template, script FROM scripts",
        result: "int, string, string, int, int, string, string, string"
    },
    getScript:
    {
        stmt: "SELECT id, name, regexp, type, source, pattern, template, script FROM scripts WHERE id = ?1",
        result: "int, string, string, int, int, string, string, string"
    },
    getNames:
    {
        stmt: "SELECT id, name FROM scripts ORDER BY name",
        result: "int, string"
    },
    insertScript:
    {
        stmt: "INSERT INTO scripts (name, regexp, type, source, pattern, template, script) VALUES (:name, :regexp, :type, :source, :pattern, :template, :script)"
    },
    updateScript:
    {
        stmt: "UPDATE scripts SET name = :name, regexp = :regexp, type = :type, source = :source, pattern = :pattern, template = :template, script = :script WHERE id = :id"
    },
    removeScript:
    {
        stmt: "DELETE FROM scripts WHERE id = ?1"
    }
};
